{-# LANGUAGE GADTs #-}
module Program where
    -- The  Program  type has been put into a separate module,
    -- so that the code examples can reuse it.

    -- Fancy list of instructions,
    -- with return types and the ability to bind variables
data Program instr a where
    Then   :: instr a -> (a -> Program instr b) -> Program instr b
    Return :: a -> Program instr a

    -- program from a single instruction
singleton :: instr a -> Program instr a
singleton i = i `Then` Return


instance Monad (Program instr) where
        -- empty program
    return = Return
    
        -- concatenation
    (Return a)    >>= js  = js a
    (i `Then` is) >>= js  = i `Then` (\a -> is a >>= js)
