{-# LANGUAGE GADTs, FlexibleInstances #-}
module StackMachineMonad where

-- Representation
type Program instr    = [instr]
type StackProgram     = Program StackInstruction
data StackInstruction = Push Int | Pop

-- Concatenation and interface
empty = []

pop  :: StackProgram
push :: Int -> StackProgram
pop    = Pop : []
push n = Push n : []

-- Interpreter
type Stack a = [a]

interpret :: StackProgram -> (Stack Int -> Stack Int)
interpret (Push a : is) stack = interpret is (a : stack)
interpret (Pop    : is) stack = interpret is (tail stack)
interpret []            stack = stack

-- Examples, try for instance
    --      > interpret example []
    --      > interpret (replace 5) [3] 

example      = Push 5 : Push 42 : Pop : []
exampleTwice = example ++ example
replace a    = pop ++ push a
